define("tiny_multilang2/ui",["exports","./options"],(function(_exports,_options2){Object.defineProperty(_exports,"__esModule",{value:!0}),_exports.onSubmit=_exports.onInit=_exports.onFocus=_exports.onDelete=_exports.onBeforeGetContent=_exports.applyLanguage=void 0;
/**
   * Commands for the plugin logic of the Moodle tiny_multilang2 plugin.
   *
   * @module      tiny_multilang2
   * @author      Iñaki Arenaza <iarenaza@mondragon.edu>
   * @author      Stephan Robotta <stephan.robotta@bfh.ch>
   * @author      Tai Le Tan <dev.tailetan@gmail.com>
   * @copyright   2015 onwards Iñaki Arenaza & Mondragon Unibertsitatea
   * @license     http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
   */
const spanClass="multilang-begin mceNonEditable",spanFixedAttrs='<span contenteditable="false" class="'+spanClass+'" data-mce-contenteditable="false"',spanMultilangBegin=spanFixedAttrs+' lang="%lang" xml:lang="%lang">{mlang %lang}</span>',spanMultilangEnd=spanFixedAttrs.replace("begin","end")+">{mlang}</span>",isNull=a=>null==a;let _isSubmit=!1;const _options={},addVisualStyling=function(ed){let content=ed.getContent();if(-1!==content.indexOf(spanClass))return content;content=content.replace(new RegExp("{\\s*mlang\\s+([^}]+?)\\s*}","ig"),(function(match,p1){return spanMultilangBegin.replace(new RegExp("%lang","g"),p1)})),content=content.replace(new RegExp("{\\s*mlang\\s*}","ig"),spanMultilangEnd);const doc=(new DOMParser).parseFromString(content,"text/html");if(0===doc.children.length)return content;const nodes=doc.querySelectorAll("span.multilang");if(0===nodes.length)return content;for(const span of nodes){const newSpan=spanMultilangBegin.replace(new RegExp("%lang","g"),span.getAttribute("lang")).replace("mceNonEditable","mceNonEditable fallback")+span.innerHTML+spanMultilangEnd.replace("mceNonEditable","mceNonEditable fallback");span.insertAdjacentHTML("afterend",newSpan),span.remove()}return doc.getElementsByTagName("body")[0].innerHTML},removeVisualStyling=function(ed){["begin","end"].forEach((function(t){for(const span of ed.dom.select("span.multilang-"+t))if("begin"===t&&span.classList.contains("fallback")){let innerHTML="",end=span,toRemove=[];for(;end&&(end=end.nextSibling,!isNull(end));){if(!isNull(end.classList)&&end.classList.contains("multilang-end")){toRemove.push(end);break}3===end.nodeType?innerHTML+=end.nodeValue:1===end.nodeType&&(innerHTML+=end.outerHTML),toRemove.push(end)}if(!isNull(end)){const lang=span.innerHTML.match(new RegExp("{\\s*mlang\\s+([^}]+?)\\s*}","i"));if(lang){const newHTML='<span class="multilang" lang="'.concat(lang[1],'">').concat(innerHTML,"</span>");for(end of(ed.dom.setOuterHTML(span,newHTML),toRemove))ed.dom.remove(end)}}}else ed.dom.setOuterHTML(span,span.innerHTML.toLowerCase())}))},getHighlightNodeFromSelect=function(ed,search){let span;return ed.dom.getParents(ed.selection.getStart(),(elm=>{if(!isNull(elm.classList)){const pair="begin"===search?"end":"begin";if(elm.classList.contains("multilang-"+pair)){span=elm;do{span="begin"===search?span.previousSibling:span.nextSibling}while(!isNull(span)&&(isNull(span.classList)||!span.classList.contains("multilang-"+search)))}else elm.classList.contains("multilang-"+search)&&(span=elm)}})),span},hideContentToolbar=function(el){for(;!isNull(el);){if(el.nodeType===Node.ELEMENT_NODE&&!isNull(el.getAttribute("class"))&&-1!=el.getAttribute("class").indexOf("tox-pop-"))return void(el.style.display="none");el=el.parentNode}};_exports.onInit=function(ed,options){Object.keys(options).forEach((function(key){_options[key]=options[key]})),ed.setContent(addVisualStyling(ed)),(0,_options2.isContentToHighlight)(ed)&&ed.dom.addStyle((0,_options2.getHighlightCss)(ed))};_exports.onBeforeGetContent=function(ed,content){if(!isNull(content.source_view)&&!0===content.source_view){var onClose=function(ed){ed.off("close",onClose),ed.setContent(addVisualStyling(ed))};ed.on("CloseWindow",(()=>{onClose(ed)})),removeVisualStyling(ed)}};_exports.onFocus=function(ed){_isSubmit&&(ed.setContent(addVisualStyling(ed),{no_events:!0}),_isSubmit=!1)};_exports.onSubmit=function(ed){removeVisualStyling(ed),_isSubmit=!0};_exports.onDelete=function(ed,event){if(event.isComposing||isNull(event.clientX)&&46!==event.keyCode&&8!==event.keyCode)return;if(!isNull(event.clientX)&&(event.target.nodeType!==Node.ELEMENT_NODE||"path"!==event.target.nodeName&&"svg"!==event.target.nodeName))return;const begin=getHighlightNodeFromSelect(ed,"begin"),end=getHighlightNodeFromSelect(ed,"end");isNull(begin)||isNull(end)||(event.preventDefault(),ed.dom.remove(begin),ed.dom.remove(end),isNull(event.clientX)||hideContentToolbar(event.target),cleanupBogus(ed))};const cleanupBogus=function(ed){for(const span of ed.dom.select('span[class*="multilang"')){const p=span.parentElement;!isNull(p.classList)&&p.classList.contains("mce-offscreen-selection")&&ed.dom.remove(p)}};_exports.applyLanguage=function(ed,iso,event){if(isNull(iso))return;if("remove"===iso){return void ed.contentDocument.body.querySelectorAll(".multilang-begin, .multilang-end").forEach((element=>{ed.dom.remove(element)}))}const regexLang=/%lang/g;let text=ed.selection.getContent();if(""===text.toString().replace(/^\s+/,"").replace(/\s+$/,"")){if(!isNull(event))return void hideContentToolbar(event.target);let newtext=spanMultilangBegin.replace(regexLang,iso)+" "+spanMultilangEnd;return(0,_options2.mlangFilterExists)(ed)||(newtext=newtext.replaceAll("mceNonEditable","mceNonEditable fallback")),void ed.insertContent(newtext)}isNull(event)||hideContentToolbar(event.target);const span=getHighlightNodeFromSelect(ed,"begin");if(!isNull(span)){let replacement=spanMultilangBegin.replace(regexLang,iso);return span.classList.contains("fallback")&&(replacement=replacement.replace("mceNonEditable","mceNonEditable fallback")),ed.dom.setOuterHTML(span,replacement),void cleanupBogus(ed)}if(-1!==text.indexOf("multilang-begin")||-1!==text.indexOf("multilang-end"))return void ed.notificationManager.open({text:_options.langInSelectionErrMsg,type:"error"});const block=function(text){let result={el:null,cnt:0};const body=(new DOMParser).parseFromString(text,"text/html").body;if(body.firstChild.nodeType!==Node.ELEMENT_NODE)return result;const blockTags=["address","article","aside","blockquote","dd","div","dl","dt","figcaption","h1","h2","h3","h4","h5","h6","li","ol","p","pre","section","tfoot","ul"];for(let i=0;i<body.children.length;i++)body.children[i].nodeType===Node.ELEMENT_NODE&&-1!==blockTags.indexOf(body.children[i].tagName.toString().toLowerCase())&&(result.cnt+=1,isNull(result.el)&&(result.el=body.children[i]));return result}(text);if(!isNull(block.el)){if(1===block.cnt){let newtext=spanMultilangBegin.replace(regexLang,iso)+block.el.innerHTML+spanMultilangEnd;return(0,_options2.mlangFilterExists)(ed)||(newtext=newtext.replaceAll("mceNonEditable","mceNonEditable fallback")),block.el.innerHTML=newtext,void ed.selection.setContent(block.el.outerHTML)}if(!(0,_options2.mlangFilterExists)(ed))return void ed.notificationManager.open({text:_options.multipleBlocksErrMsg,type:"error"})}let newtext=spanMultilangBegin.replace(regexLang,iso)+text+spanMultilangEnd;(0,_options2.mlangFilterExists)(ed)||(newtext=newtext.replaceAll("mceNonEditable","mceNonEditable fallback")),ed.selection.setContent(newtext)}}));

//# sourceMappingURL=ui.min.js.map